// The contents of this file are subject to the Mozilla Public
// License Version 1.1 (the "License"); you may not use this file
// except in compliance with the License. You may obtain a copy of
// the License at http://www.mozilla.org/MPL/
//    
// Software distributed under the License is distributed on an "AS
// IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
// implied. See the License for the specific language governing
// rights and limitations under the License.
//    
// The Original Code is Archangel.
// The Initial Developer of the Original Code is Thomas Thurman
//    
// Portions created by Thomas Thurman are
// Copyright (C) 2002 Thomas Thurman.
// All Rights Reserved.
//
////////////////////////////////////////////////////////////////

// Persistent state for associative arrays.
// (This could use a lot more documentation.)

////////////////////////////////////////////////////////////////

include('chrome://jslib/content/io/file.js');
include('chrome://jslib/content/io/dir.js');

var persistBaseDir;

function persistSetDirectory(dir) {
	persistBaseDir = dir;
}

function persistStore(stuff) {
	var f = new File(persistBaseDir.path);

	f.append(stuff['name']);
	f.open('w');
	for (line in stuff)
		if (line!='name')
			f.write(line+'='+stuff[line]+'\n');

	f.close();
}

function persistRecall(name) {
	var f = new File(persistBaseDir.path);
	var a = new Array();

	f.append(name);

	if (f.exists()) {
		f.open('r');
		while (!f.EOF) {
			var line = f.readline();
			var equals = line.indexOf('=');
			if (equals!=-1) {
				a[line.substring(0, equals)] =
					line.substring(equals+1);
			}
		}

		f.close();
	}

	// Otherwise, just give them back an empty array.

	a['name'] = name;
	return a;
}